//all DDR2 registers
#define MIDR    ( *(int*)(0x78000000))
#include <stdio.h>
#include "file.h"
#include <string.h>


#define DMCSTAT ( *(int*)(0x78000004))
#define SDCFG   ( *(int*)(0x78000008))
#define SDRFC   ( *(int*)(0x7800000c))
#define SDTIM1  ( *(int*)(0x78000010))
#define SDTIM2  ( *(int*)(0x78000014))
#define BPRIO   ( *(int*)(0x78000020))
#define DMCCTL  ( *(int*)(0x780000E4))

#define SDCFG_VALUE   0x00538832
#define SDRFC_VALUE   0x0000079E
#define SDTIM1_VALUE  0x3ed85b91
#define SDTIM2_VALUE  0x00a2c722 

#define	ddr2_base     0xE0000000;
unsigned char *flash_ptr;
unsigned char read_data[10];
char i = 0;
int errnum = 0;


volatile int DMCCTL_val;
//DDR2CLKOUT=250MHZ
void InitDDR2()
{
//put the ddr2 congtroller in reset state
 BPRIO = 0x000000fe;//refer to silicon errordata revision E;
 DMCCTL =  (DMCCTL|0x00000020);    //λ1  
 DMCCTL =  (DMCCTL&0xfffffffd);   //1λ0  ƲΪ101=5=CAS+1  CAS=4
 SDCFG = SDCFG_VALUE;
 SDRFC = SDRFC_VALUE;
 SDTIM1 = SDTIM1_VALUE;
 SDTIM2 = SDTIM2_VALUE;
//LOCK THE SDTIM1&SDTIM2
 SDCFG = (SDCFG&0xFFFF7FFF);
//bring the controller out of reset
 DMCCTL = (DMCCTL&0xffffffdf);
 
 if((DMCSTAT>>31)==0x00000000)
 {printf("DDR2 controller is in little endian mode.!\n");}
 else if((DMCSTAT>>31)==0x00000001)
  {printf("DDR2 controller is in big endian mode.!\n");}

  while((DMCSTAT&0x00000004)>>2 != 0x00000001)
  {printf("wating for DDR2 controller to be ready.!\n");}
  
  printf("DDR2 controller is ready for opration.!\n");
}

void write_ddr2(unsigned char *address,unsigned char data)
{
	*address=data;
	
}

unsigned char read_ddr2(unsigned char *address)
{
	unsigned char temp;
	temp=*address;
	return temp;
	 
}

void test_ddr2()
{
 flash_ptr=(unsigned char *)ddr2_base;

 for(i=0;i<10;i++)
 {
	write_ddr2(flash_ptr++,i);
  }
 flash_ptr=(unsigned char *)ddr2_base;
 
 for(i=0;i<10;i++)
 {
	read_data[i]=read_ddr2(flash_ptr++);
	if(read_data[i]!=i)
	{
		errnum++;
	}
 }
 printf("The error number of  test is %d(word)\n",errnum);

}
